procedure cparse (cline)

string	cline	=""	{prompt="character string to parse"}
char	delim	=" "	{prompt="field delimiting character or string"}
int	nselect	=1	{prompt="select field"}
string	cfield	=""	{prompt="value of selected field"}
int	nfields	=0	{prompt="number of fields in string"}
bool	lignore =yes	{prompt="ignore leading delimiters?"}
bool	mignore =yes	{prompt="ignore multiple delimiters?"}
bool	verbose =no	{prompt="print selected field?"}

# @(#) task cparse                    Author: R.A. Jansen -- Jul 29 2003
# @(#) 
# @(#) Task to parse  a character string  into separate fields  given an
# @(#) arbitrary  field delimiting character (e.g., " ", ":", ",", "/"),
# @(#) or character string (e.g., ".hhh"). Leading delimiting characters
# @(#) are ignored by default, as are multiple delimiters,  but this be-
# @(#) havior may be changed  by the user.  The  selected field  and the
# @(#) total number of fields in the string are returned as task parame-
# @(#) ters.  If the specified field number  is larger than  the maximum
# @(#) number of fields in the string,  the last field in the string  is
# @(#) returned.  Usually,  a string contains  at least one field,  even 
# @(#) when the specified delimiter does not occur in that string at all
# @(#) (then, the field equals the entire string).  But if 'lignore=yes'
# @(#) and 'cline' equals 'delim', this task will return 'cfield=""' and
# @(#) 'nfields=0' upon exit.  If 'nselect=INDEF', 'nfields' will return
# @(#) the number of fields, but 'cfield' will be empty upon exit.
# @(#)
# @(#) Apr.23 1996 -- Original 15-field version of this task. RAJ.
# @(#) Jun.28 2000 -- Added option to select a specific field by giving
# @(#)                its field number (useful in loops). RAJ.
# @(#) Jul.29 2003 -- Complete rewrite of this task and its scope. RAJ.

begin
	string	cstr, sep, cfld, fsel, ftmp, cc, ccold
	int	nsel, nsep, nfld, i, nc
	bool	nolead, nomult

#	Initialize variables ...
	cstr   = cline
	sep    = delim
	nsel   = nselect
	nolead = lignore
	nomult = mignore
	cfld   = ""
	fsel   = ""
	ftmp   = ""
	cc     = " "
	ccold  = cc

#	Set default delimiter to <space> ...
	if ( sep == "" ) { sep = " " }
	nsep = strlen(sep)

#	Search through string, while (optionally) ignoring leading and /
#	or multiple delimiters ...
	nfld = 0
	nc   = strlen(cstr) - nsep + 1
	i    = 1
	while ( i <= nc ) {
	   cc = substr(cstr,i,i+nsep-1)
	   if ( cc != sep && i != nc ) {
	      ftmp = ftmp//substr(cc,1,1)
	      i = i + 1
	   } else if ( nfld == 0 && cc == sep && ccold == " " && nolead ) {
	      # ignore leading delimiter(s)...
	      i = i + nsep
	      cc = " "
	   } else if ( cc == sep && ccold == sep && nomult ) {
	      # ignore multiple delimiters...
	      i = i + nsep
	   } else if ( cc == sep || i == nc ) {
	      if ( i == nc && cc != sep ) {
		 ftmp = ftmp//cc
	      }
	      nfld = nfld + 1
	      if ( nfld <= nsel ) { fsel = ftmp }
	      ftmp = ""
	      i = i + nsep
	   }
	   ccold = cc
	}

#	Update task parameters...
	cline	= cstr
	delim	= sep
	nselect	= nsel
	cfield	= fsel
	nfields	= nfld

#	Verbose output...
	if (verbose) { print (fsel) }

end
