procedure gdate ()

bool	utc	=no	{prompt="Return UTC rather than local time?"}
string  date	=""	{prompt="Date (Europe)"}
string	cdate	=""	{prompt="Date (US)"}
string	ldate	=""	{prompt="Date (Europe)"}
string	day	=""	{prompt="Abbreviated day"}
string	month	="" 	{prompt="Abbreviated month"}
string	year	=""	{prompt="Year"}
string	time	=""	{prompt="Time"}
string	tzone	=""	{prompt="Time zone"}
string  fdate	=""	{prompt="FITS standard format date string"}
string	tdate	=""	{prompt="Date and time"}
string  adate   =""	{prompt="Date and time"}
string	ddate	=""	{prompt="Date and time"}
string	sdate	=""	{prompt="Date and time"}
string	ndate	=""	{prompt="Numeric date string (logical)"}
string	udate	=""	{prompt="Numeric date string (US)"}
string	edate	=""	{prompt="Numeric date string (Europe)"}
int	nyear		{prompt="Year number"}
int	nmon		{prompt="Month number of the year"}
int	nday		{prompt="Day number of the month"}
real	yday		{prompt="Fractional day number of the year"}
real	jd		{prompt="Julian day number"}

# @(#) task gdate                    Author: R.A. Jansen -- Jan 26, 1996
# @(#)
# @(#) Return the current date and components thereof in various formats
# @(#) either in UTC  or in Local Time  (except 'fdate', which is always
# @(#) UTC).
# @(#)
# @(#) Jul 31 2003 -- Fixed 'fdate' and 'jd' to UTC; added 'yday'. RAJ.

begin
	string	ldy, lmn, ltm, ltz, lyr, limn, lidy, ccmn[12]
	string	udy, umn, utm, utz, uyr, uimn, uidy, cimn[12]
	int	i, ildy, iudy
	real	rjd, fjd
	bool	butc

	butc = utc

#	Get the Universal time... 
	# Since the 'CL' refuses to pass argument '-u' to foreign task
	# 'date' from within a script, and native task 'time' lacks an
	# option to return UTC, we need the following work-around:
	!date -u > .tmpgdte
	type (".tmpgdte") | scanf ("%s %s %d %s %s %s",udy,umn,iudy,utm,utz,uyr)
	delete(".tmpgdte", yes, verify=no)

#	Get the Local time...
	# Without arguments, there is no problem getting the local time
	date | scanf ("%s %s %d %s %s %s",ldy,lmn,ildy,ltm,ltz,lyr)

#	Set month abbreviations...
	ccmn[1]="Jan"; ccmn[2]="Feb"; ccmn[3]="Mar"; ccmn[4]="Apr"
	ccmn[5]="May"; ccmn[6]="Jun"; ccmn[7]="Jul"; ccmn[8]="Aug"
	ccmn[9]="Sep"; ccmn[10]="Oct"; ccmn[11]="Nov"; ccmn[12]="Dec"
	for (i = 1 ; i <= 12 ; i += 1 ) {
	   printf("%02d\n",i) | scan (cimn[i])
	   if ( umn == ccmn[i] ) { uimn = cimn[i] }
	}
	for (i = 1 ; i <= 12 ; i += 1 ) {
	   if ( lmn == ccmn[i] ) { limn = cimn[i] }
	}

#	Day number of the month as a string...
	printf("%02d\n",iudy) | scan (uidy)
	printf("%02d\n",ildy) | scan (lidy)

#	Set parsed date strings...
	if (butc) {
	   date  = uidy//" "//umn//" "//uyr
	   cdate = umn//" "//uidy//", "//uyr
	   ldate = uidy//"-"//umn//"-"//uyr
	   day   = udy
	   month = umn
	   year  = uyr
	   time  = utm
	   tzone = utz
	} else {
	   date  = lidy//" "//lmn//" "//lyr
	   cdate = lmn//" "//lidy//", "//lyr
	   ldate = lidy//"-"//lmn//"-"//lyr
	   day   = ldy
	   month = lmn
	   year  = lyr
	   time  = ltm
	   tzone = ltz
	}

#	Set composite date and time strings...

	# FITS standard format date string (always UTC per definition)
	fdate	= uyr//"-"//uimn//"-"//uidy//"T"//utm

	# Current approximate Julian date (UTC) ...
	if ( !defpac("astutil") ) { astutil }
	asttimes (files="", header=no, year=int(uyr), month=int(uimn),
		day=int(uidy), time=real(utm), obs="lapalma", > "dev$null")
	rjd = asttimes.jd
	printf("%.2f\n", rjd) | scan (fjd)
	jd = fjd
	# Approximate Julian date at Jan 1 0:00:00...
	asttimes (files="", header=no, year=int(uyr), month=1, day=1,
		time=0.000000, obs="lapalma", > "dev$null")

	if (butc) {
	   # Date and time (%Mmm %dd %YYyy %hh:mm:ss)
	   tdate  = umn//" "//uidy//" "//utm//" "//uyr
	   # Date and time (%Ddd %dd-%Mmm-%YYyy %hh:mm:ss)
	   adate = udy//" "//uidy//"-"//umn//"-"//uyr//" "//utm
	   # Date and time (%Ddd %Mmm %dd %hh:mm:ss %Zzz %YYyy)
	   ddate  = udy//" "//umn//" "//uidy//" "//utm//" "//utz//" "//uyr
	   # Date and time (%dd-%Mmm-%YYyy %hh:mm:ss %Zzz)
	   sdate  = uidy//"-"//umn//"-"//uyr//" "//utm//" "//utz
	   # Numeric date string (logical) (%YYyy/%mm/%dd)
	   ndate  = uyr//"/"//uimn//"/"//uidy
	   # Numeric date string (US) (%mm/%dd/%yy)
	   udate  = uimn//"/"//uidy//"/"//substr(uyr,3,4)
	   # Numeric date string (Europe) (%dd/%mm/%yy)
	   edate  = uidy//"/"//uimn//"/"//substr(uyr,3,4)
	   nyear  = int(uyr)
	   nmon   = int(uimn)
	   nday   = iudy
	} else {
	   # Date and time (%Mmm %dd %YYyy %hh:mm:ss)
	   tdate  = lmn//" "//lidy//" "//ltm//" "//lyr
	   # Date and time (%Ddd %dd-%Mmm-%YYyy %hh:mm:ss)
	   adate = ldy//" "//lidy//"-"//lmn//"-"//lyr//" "//ltm
	   # Date and time (%Ddd %Mmm %dd %hh:mm:ss %Zzz %YYyy)
	   ddate  = ldy//" "//lmn//" "//lidy//" "//ltm//" "//ltz//" "//lyr
	   # Date and time (%dd-%Mmm-%YYyy %hh:mm:ss %Zzz)
	   sdate  = lidy//"-"//lmn//"-"//lyr//" "//ltm//" "//ltz
	   # Numeric date string (logical) (%YYyy/%mm/%dd)
	   ndate  = lyr//"/"//limn//"/"//lidy
	   # Numeric date string (US) (%mm/%dd/%yy)
	   udate  = limn//"/"//lidy//"/"//substr(lyr,3,4)
	   # Numeric date string (Europe) (%dd/%mm/%yy)
	   edate  = lidy//"/"//limn//"/"//substr(lyr,3,4)
	   nyear  = int(lyr)
	   nmon   = int(limn)
	   nday   = ildy
	}

	# Fractional day of the year
	printf("%.6f\n",(rjd-asttimes.jd)) | scan(fjd)
	yday = fjd

end
