procedure sysinfo()

string	host	=""		{prompt="Host system name"}
string	arch	=""		{prompt="Host system architecture"}
string	userid	=""		{prompt="User id (short)"}
string	username=""		{prompt="User name (full)"}
string	path	=""		{prompt="Current working directory"}
string	origin	=""		{prompt="Origin of IRAF distribtion"}
string	version	=""		{prompt="Version of IRAF running on host"}
string	sysmsg	=""		{prompt="Composite message for logging"}

# @(#) task sysinfo                  Author: R.A. Jansen -- July  5 1997
# @(#)
# @(#) Simple task returning the name of the host machine, user name and
# @(#) current working directory path and the version of IRAF running on
# @(#) the host machine. This task is useful for creating stamps in text
# @(#) logs in conjunction with 'gdate'.  The generic format of 'sysmsg'
# @(#) is:   'version'//"  "//'userid'//"@"//'host'
# @(#) Note, that in order for 'username' to be non-empty the user needs
# @(#) to add a line (which may be a copy of the line defining 'userid')
# @(#) to his/her 'login.cl' file:  set username = "John/Jane D'Oh"
# @(#)
# @(#) Uses 'rjtools' task:  'cparse'
# @(#)
# @(#) Aug  5 2003 -- Cleaned up code a bit; added 'sysmsg'. RAJ.
# @(#) Apr 25 2004 -- Added 'arch' and 'origin' parameters. RAJ.

begin
	string	ctmp, chos, carc, cpat, cusr, cnam, corg, cver

#	Query system environment...
	path () | scan (ctmp)
	cparse (ctmp, delim="!", nselect=1)
	chos = cparse.cfield

	cparse (ctmp, delim="!", nselect=2)
	cpat = cparse.cfield

	ctmp = envget("arch")
	carc = substr(ctmp,2,strlen(ctmp))

	cusr = envget("userid")
	cnam = "" ; cnam = envget("username")

	ctmp = envget("version")
	cparse (ctmp, delim=" ", nselect=1)
	corg = cparse.cfield

	cparse (ctmp, delim=" ", nselect=2)
	cver = cparse.cfield

#	Update task parameters and return...
	host	= chos
	arch	= carc
	path	= cpat
	userid	= cusr
	username= cnam
	origin	= corg
	version	= cver
	if ( substr(cver,strlen(cver)-6,strlen(cver)) == "-EXPORT" ) {
	   cver = substr(cver,1,strlen(cver)-7)
	} else if ( substr(cver,strlen(cver)-5,strlen(cver)) == "EXPORT" ) {
	   cver = substr(cver,1,strlen(cver)-6)
	}
	if ( substr(cver,1,1) == "V" || substr(cver,1,1) == "v" ) {
	   cver = substr(cver,2,strlen(cver))
	}
	if ( substr(corg,1,5) == "NOAO/" ) {
	   corg = substr(corg,6,strlen(corg))
	}
	sysmsg = corg//cver//"  "//cusr//"@"//chos

end
